/*
 * Camera.cpp
 *
 *  Created on: Sep 14, 2009
 *      Author: dportnoy
 */

#include "Camera.hpp"

#define NO_SDL_GLEXT
#include <SDL_opengl.h>

#include <cmath>

Camera::Camera() : translate(make_vector(0.0f, 0.0f, 0.0f)), rotate(make_vector(0.0f, 0.0f, 0.0f)),
					scale(make_vector(1.0f, 1.0f, 1.0f)) {

}

Camera::~Camera() {

}

void Camera::applyTransform() {
	glRotatef(rotate.x, 1.0f, 0.0f, 0.0f);
	glRotatef(rotate.y, 0.0f, 1.0f, 0.0f);
	//ignore z-axis rotation since we probably won't be using it anyway

	glTranslatef(translate.x, translate.y, translate.z);

	//ignore scale for now
}

//moves the camera a certain distance in the direction it is currently facing
void Camera::move(float dist) {
	float x = rotate.x/180*3.14159265;
	float y = rotate.y/180*3.14159265;

	//result of multiplying (0,0,dist) by the x rotation matrix and the y rotation matrix
	translate.x += -dist*cos(x)*sin(y);
	translate.y += dist*sin(x);
	translate.z += dist*cos(x)*cos(y);
}
