/*
 * Game.hpp
 *
 *  Created on: Aug 29, 2009
 *      Author: dportnoy
 */

#ifndef GAME_HPP_
#define GAME_HPP_

#include <vector>

#include <Basis/Screen.hpp>

#include "Object.hpp"
#include "Camera.hpp"

class Game : public Screen {
public:
	Vector2f mouse_pos;
	Camera cam;
	Uint8 *keystates;

	float time_acc;
	int energy_acc;
	std::vector<Object> objects;

	GLUquadricObj *quadric;
	Object ball;

	Game();
	virtual ~Game();
	virtual void draw();
	void tick();		//perform fixed-step update
	virtual void update(float elapsed);
	virtual void handle_event(SDL_Event const &event);
};

#endif /* GAME_HPP_ */
