/*
 * Object.cpp
 *
 *  Created on: Sep 11, 2009
 *      Author: dportnoy
 */

#include "Object.hpp"

#include <Vector/VectorGL.hpp>

void drawTriangleWithNormals(Vector3f v1, Vector3f v2, Vector3f v3) {
	glVertex(v1);
	glVertex(v2);
	glVertex(v3);
}

Object::Object() {
	list = 0;
	translate = make_vector(0.0f, 0.0f, 0.0f);
	rotate = make_vector(0.0f, 0.0f, 0.0f);
	scale = make_vector(1.0f, 1.0f, 1.0f);
}

Object::~Object() {

}

void Object::draw() {
	glPushMatrix();

	glTranslatef(translate.x, translate.y, translate.z);
	glRotatef(rotate.y, 0.0f, 1.0f, 0.0f);
	glScalef(scale.x, scale.y, scale.z);
	glCallList(list);

	glPopMatrix();
}
